<script lang="ts">
  import { page } from '$app/stores';
  import DrawerMenu from '@svelte-common/menu/DrawerMenu.svelte';
  import type { Side } from '@svelte-common/menu/hamburger-menu/hamburger-menu.js';
  import { drawerMenuStore, isOpened } from '@svelte-common/menu/stores/drawer-menu-store.js';
  import { scrollLock } from '@web-common/hooks/browser/scroll-lock.js';
  import { onDestroy, onMount } from 'svelte';
  import MobileSitemap from '../footer/sitemaps/MobileSitemap.svelte';
  import Links from './Links.svelte';

  export let side: Side = 'right';

  let scrollLockCb: CallbackWith<boolean>;

  $: scrollLockCb?.($isOpened);

  onMount(() => {
    const { lock, cleanUp } = scrollLock();
    scrollLockCb = lock;

    return () => cleanUp();
  });

  const unsubscribe = page.subscribe((data) => {
    drawerMenuStore.toggle(false);
  });

  onDestroy(() => {
    unsubscribe();
  });
</script>

<DrawerMenu
  {side}
  drawerClass="drawer-style"
  ><nav class="nav">
    <Links />
    <!-- <div class="account-panel"><img src={SVGs.account} /></div> -->
  </nav>
  <div class="sitemap"><MobileSitemap /></div></DrawerMenu>

<style lang="postcss">
  .account-panel {
    position: absolute;
    top: 60px;
    width: 100%;
    height: 150px;
    padding: var(--content-margin);
    background-color: blueviolet;
  }

  .nav :global(.logo) {
    position: absolute;
    top: 10px;
    width: 300px;
  }

  .nav :global(li:nth-child(2)) {
    margin-top: 150px;
  }

  .sitemap {
    position: absolute;
    bottom: 0;
    width: 100%;
  }

  :global(.drawer-style) {
    height: 100vh;
    background-image: linear-gradient(
      to right bottom,
      hsl(176deg 100% 84%),
      hsl(184deg 84% 75%),
      hsl(189deg 85% 68%),
      hsl(193deg 86% 60%),
      hsl(196deg 86% 52%)
    );

    /* --drawer-animation-in: 0.3s ease-in-out; */

    & :global(ol) {
      width: 100vw;
      padding: 0;
      margin: 0;
    }

    & :global(ol > li) {
      display: flex;
      flex-direction: column;
    }

    & :global(a) {
      display: block; /* Make the anchor tags full-width within the <li> elements */
      padding: 0.5rem 2rem;
      color: black;
      font-size: x-large;
      font-weight: bold;
      text-decoration: none; /* Optional: Remove underlines from the links */
    }

    & :global([aria-current='page'] > a) {
      color: var(--color-theme-1);
    }
  }
</style>
